/**
* Copyright (c) 2017 committers of YAKINDU and others.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*     committers of YAKINDU - initial API and implementation
*/
#include "gtest/gtest.h"
#include "STextKeywordsInStatesAndRegions.h"

static STextKeywordsInStatesAndRegions statechart;

class StatemachineTest : public ::testing::Test{
	protected:
	virtual void SetUp() {
		sTextKeywordsInStatesAndRegions_init(&statechart);
	}
};


TEST_F(StatemachineTest, activeCheckWithSTextNamedStates) {					
	sTextKeywordsInStatesAndRegions_enter(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_raise));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_active));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_interface));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_event));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_in));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_var));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_external));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_default));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_entry));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_always));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_raise));
	sTextKeywordsInStatesAndRegionsIface_raise_e1(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_valueof));
	sTextKeywordsInStatesAndRegionsIface_raise_e2(&statechart);
	sTextKeywordsInStatesAndRegions_runCycle(&statechart);
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_default_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_operation_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_namespace_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_local_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_interface_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_internal_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_event_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_in_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_out_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_var_valueof));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_readonly_namespace));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_external_internal));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_else_local));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_entry_out));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_exit_readonly));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_always_operation));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_oncycle_else));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_raise_exit));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_valueof_oncycle));
	EXPECT_TRUE(sTextKeywordsInStatesAndRegions_isStateActive(&statechart, STextKeywordsInStatesAndRegions_active_valueof));
}


