/**
* Copyright (c) 2017 committers of YAKINDU and others.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*     committers of YAKINDU - initial API and implementation
*/

package org.yakindu.sct.generator.java.test;

import org.junit.*;
import static org.junit.Assert.*;
import org.yakindu.scr.alwaysoncycle.AlwaysOncycleStatemachine;
import org.yakindu.scr.alwaysoncycle.AlwaysOncycleStatemachine.State;	

/**
 * Unit TestCase for AlwaysOncycle
 */
@SuppressWarnings("all")
public class AlwaysOncycle {
	
	private AlwaysOncycleStatemachine statemachine;	
	
	
	
	@Before
	public void alwaysOncycle_setUp() {
		statemachine = new AlwaysOncycleStatemachine();
		statemachine.init();
	}

	@After
	public void alwaysOncycle_tearDown() {
		statemachine = null;
	}
	
	@Test
	public void alwaysOnCycleTest() {
		statemachine.enter();
		assertTrue(statemachine.isStateActive(State.main_region_StateA));
		while (statemachine.getValue() < 5l) {
			statemachine.runCycle();
			assertTrue(statemachine.isStateActive(State.main_region_StateA));
		}
		statemachine.runCycle();
		assertTrue(statemachine.isStateActive(State.main_region_StateB));
		while (statemachine.getValue() < 5l) {
			statemachine.runCycle();
			assertTrue(statemachine.isStateActive(State.main_region_StateB));
		}
		statemachine.runCycle();
		assertTrue(statemachine.isStateActive(State.main_region_StateA));
	}
}
