/**
* Copyright (c) 2017 committers of YAKINDU and others.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*     committers of YAKINDU - initial API and implementation
*/

package org.yakindu.sct.generator.java.test;

import org.junit.*;
import static org.junit.Assert.*;
import org.yakindu.scr.readonlyvariable.ReadOnlyVariableStatemachine;
import org.yakindu.scr.readonlyvariable.ReadOnlyVariableStatemachine.State;	

/**
 * Unit TestCase for ReadOnlyVariable
 */
@SuppressWarnings("all")
public class ReadOnlyVariable {
	
	private ReadOnlyVariableStatemachine statemachine;	
	
	
	
	@Before
	public void readOnlyVariable_setUp() {
		statemachine = new ReadOnlyVariableStatemachine();
		statemachine.init();
	}

	@After
	public void readOnlyVariable_tearDown() {
		statemachine = null;
	}
	
	@Test
	public void readOnlyVariableTest() {
		statemachine.enter();
		assertTrue(statemachine.isStateActive(State.main_region_StateA));
		assertTrue(statemachine.getMyInt() == 0l);
		assertTrue(statemachine.getMyString().equals("testString"));
		assertTrue(statemachine.getMyBool() == true);
		assertTrue(statemachine.getMyReal() == 1.1);
		assertTrue(statemachine.getSCIA().getMyInt() == 0l);
		assertTrue(statemachine.getSCIA().getMyString().equals("testString"));
		assertTrue(statemachine.getSCIA().getMyBool() == true);
		assertTrue(statemachine.getSCIA().getMyReal() == 1.1);
		statemachine.runCycle();
		assertTrue(statemachine.isStateActive(State.main_region_StateB));
		assertTrue(statemachine.getMyInt() == 100l);
		assertTrue(statemachine.getMyString().equals("fail"));
		assertTrue(statemachine.getMyBool() == false);
		assertTrue(statemachine.getMyReal() == 6.6);
		assertTrue(statemachine.getSCIA().getMyInt() == 200l);
		assertTrue(statemachine.getSCIA().getMyString().equals("A_fail"));
		assertTrue(statemachine.getSCIA().getMyBool() == false);
		assertTrue(statemachine.getSCIA().getMyReal() == 7.7);
	}
}
