/**
* Copyright (c) 2017 committers of YAKINDU and others.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
*
* Contributors:
*     committers of YAKINDU - initial API and implementation
*/
package org.yakindu.sct.simulation.core.sexec.test;
import org.eclipse.xtext.junit4.InjectWith;
import org.eclipse.xtext.junit4.XtextRunner;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.yakindu.sct.model.sexec.ExecutionFlow;
import org.yakindu.sct.model.sexec.interpreter.test.util.AbstractExecutionFlowTest;
import org.yakindu.sct.model.sexec.interpreter.test.util.SExecInjectionProvider;
import org.yakindu.sct.test.models.SCTUnitTestModels;
import com.google.inject.Inject;
import static org.junit.Assert.assertTrue;
/**
 * Unit TestCase for STextKeywordsInStatesAndRegions
 */
@SuppressWarnings("all")
@RunWith(XtextRunner.class)
@InjectWith(SExecInjectionProvider.class)
public class STextKeywordsInStatesAndRegions extends AbstractExecutionFlowTest {
	@Before
	public void setup() throws Exception{
		ExecutionFlow flow = models.loadExecutionFlowFromResource("STextKeywordsInStatesAndRegions.sct");
		initInterpreter(flow);
	}
	@Test
	public void activeCheckWithSTextNamedStates() throws Exception {
		interpreter.enter();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("raise"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("active"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("interface"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("event"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("in"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("var"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("external"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("default"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("entry"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("always"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("raise"));
		raiseEvent("e1");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		raiseEvent("e2");
		interpreter.runCycle();
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
		assertTrue(isStateActive("namespace"));
		assertTrue(isStateActive("internal"));
		assertTrue(isStateActive("local"));
		assertTrue(isStateActive("out"));
		assertTrue(isStateActive("readonly"));
		assertTrue(isStateActive("operation"));
		assertTrue(isStateActive("else"));
		assertTrue(isStateActive("exit"));
		assertTrue(isStateActive("oncycle"));
		assertTrue(isStateActive("valueof"));
	}
}
